figure(9)
for vow_i=1:length(vowf_all)
    plot(vowf_all(vow_i,:), vowb_all(vow_i,:),'Marker','.','LineStyle','none')
    hold on
    plot([0,3],[0,3],'LineStyle','--','Color',[0 0 0])
    hold off
    ylim([0,max([vowf_all(vow_i,:), vowb_all(vow_i,:)])+0.1])
    xlim([0,max([vowf_all(vow_i,:), vowb_all(vow_i,:)])+0.1])
    for subj_i=1:15
        col=[1 0 0];
        txt=sprintf('%s', subject{subj_i});
        for subjn_i=1:length(subject_n)
            if strcmp(subject{subj_i},subject_n{subjn_i})
                col=[0 0 0];
                break
            end
        end
        text(vowf_all(vow_i,subj_i), vowb_all(vow_i,subj_i) , txt, 'FontSize', 10, 'Color', col);
    end

    title(sprintf('Scatter Plot Vowel %s', VOWSTIM_LIST{vow_i}),'Fontsize',18);
    txtxlabel = sprintf('Entropy of %s in initial position [bits]', VOWSTIM_LIST{vow_i});
    xlabel(txtxlabel,'Fontsize',12);
    txtylabel = sprintf('Entropy of %s in final position [bits]', VOWSTIM_LIST{vow_i});
    ylabel(txtylabel,'Fontsize',12);
    text(0.05,max([vowf_all(vow_i,:), vowb_all(vow_i,:)]), 'RD Participants', 'FontSize', 10,'Color', [1 0 0]);
    text(0.05,max([vowf_all(vow_i,:), vowb_all(vow_i,:)])*0.95, 'GR Participants', 'FontSize', 10,'Color', [0 0 0]);
    fname = sprintf('scatterentropy_vow_%s.eps', VOWSTIM_LIST{vow_i});
    print(gcf, fullfile('graphics', fname), '-depsc2');
end


figure(10)
for con_i=1:length(conf_all)
    plot(conf_all(con_i,:), conb_all(con_i,:),'Marker','.','LineStyle','none')
    hold on
    plot([0,3],[0,3],'LineStyle','--','Color',[0 0 0])
    hold off
    ylim([0,max([conf_all(con_i,:), conb_all(con_i,:)])+0.1])
    xlim([0,max([conf_all(con_i,:), conb_all(con_i,:)])+0.1])
    for subj_i=1:15
        col=[1 0 0];
        txt=sprintf('%s', subject{subj_i});
        for subjn_i=1:length(subject_n)
            if strcmp(subject{subj_i},subject_n{subjn_i})
                col=[0 0 0];
                break
            end
        end
        text(conf_all(con_i,subj_i), conb_all(con_i,subj_i) , txt, 'FontSize', 10,'Color', col);
    end

    title(sprintf('Scatter Plot Consonant %s', CONSTIM_LIST{con_i}),'Fontsize',18);
    txtxlabel = sprintf('Entropy of %s in initial position [bits]', CONSTIM_LIST{con_i});
    xlabel(txtxlabel,'Fontsize',12);
    txtylabel = sprintf('Entropy of %s in final position [bits]', CONSTIM_LIST{con_i});
    ylabel(txtylabel,'Fontsize',12);
    text(0.05,max([conf_all(con_i,:), conb_all(con_i,:)]), 'RD Participants', 'FontSize', 10,'Color', [1 0 0]);
    text(0.05,max([conf_all(con_i,:), conb_all(con_i,:)])*0.95, 'GR Participants', 'FontSize', 10,'Color', [0 0 0]);
    fname = sprintf('scatterentropy_con_%s.eps', CONSTIM_LIST{con_i});
    print(gcf, fullfile('graphics', fname), '-depsc2');
end






